diff --git a/drivers/platform/x86/thinkpad_acpi.c b/drivers/platform/x86/thinkpad_acpi.c
index 5ddf2775fb06..c20b9902270b 100644
--- a/drivers/platform/x86/thinkpad_acpi.c
+++ b/drivers/platform/x86/thinkpad_acpi.c
@@ -4013,7 +4013,7 @@ static bool hotkey_notify_usrevent(const u32 hkey,
 }
 
 static void thermal_dump_all_sensors(void);
-static void proxsensor_refresh(void);
+static void proxsensor_refresh(bool palm, bool lap);
 
 static bool hotkey_notify_6xxx(const u32 hkey,
 				 bool *send_acpi_ev,
@@ -4081,7 +4081,7 @@ static bool hotkey_notify_6xxx(const u32 hkey,
 	case TP_HKEY_EV_PALM_DETECTED:
 	case TP_HKEY_EV_PALM_UNDETECTED:
 		/* palm detected  - pass on to event handler */
-		proxsensor_refresh();
+		proxsensor_refresh(true /* palm */, false /* lap */);
 		return true;
 
 	default:
@@ -9929,6 +9929,23 @@ static struct ibm_struct dytc_driver_data = {
 struct input_dev *tpacpi_sw_dev;
 bool has_palmsensor;
 bool palmsensor_state;
+bool has_lapsensor;
+bool lapsensor_state;
+
+static int lapsensor_get(bool *present, bool *state)
+{
+	acpi_handle dytc_handle;
+	int output;
+
+	*present = false;
+	if (ACPI_FAILURE(acpi_get_handle(hkey_handle, "DYTC", &dytc_handle)))
+		return -ENODEV;
+	if (!acpi_evalf(dytc_handle, &output, NULL, "dd", DYTC_CMD_GET))
+		return -EIO;
+	*present = true; /* If we get his far, we have lapmode support */
+	*state = output & BIT(DYTC_GET_LAPMODE_BIT) ? true : false;
+	return 0;
+}
 
 static int palmsensor_get(bool *present, bool *state)
 {
@@ -9945,36 +9962,56 @@ static int palmsensor_get(bool *present, bool *state)
 	return 0;
 }
 
-static void proxsensor_refresh(void)
+static void proxsensor_refresh(bool palm, bool lap)
 {
 	bool new_state;
 	int err;
 
-	if (has_palmsensor) {
+	if (palm && has_palmsensor) {
 		err = palmsensor_get(&has_palmsensor, &new_state);
-		if (err)
-			return;
-		if (new_state != palmsensor_state) {
+		if (!err && (new_state != palmsensor_state)) {
 			input_report_switch(tpacpi_sw_dev, SW_PALMREST_PROXIMITY, new_state);
 			input_sync(tpacpi_sw_dev);
 			palmsensor_state = new_state;
 		}
 	}
+
+	if (lap && has_lapsensor) {
+		err = lapsensor_get(&has_lapsensor, &new_state);
+		if (!err && (new_state != lapsensor_state)) {
+			input_report_switch(tpacpi_sw_dev, SW_LAP_PROXIMITY, new_state);
+			input_sync(tpacpi_sw_dev);
+			lapsensor_state = new_state;
+		}
+	}
 }
 
 static int tpacpi_proxsensor_init(struct ibm_init_struct *iibm)
 {
-	int palm_err;
+	int palm_err, lap_err, err;
 
+	/* Make sure globals are set to a sensible initial value */
+	has_palmsensor = false;
+	has_lapsensor = false;
 	palm_err = palmsensor_get(&has_palmsensor, &palmsensor_state);
+	lap_err = lapsensor_get(&has_lapsensor, &lapsensor_state);
+
 	/* If support isn't available (ENODEV) then don't return an error */
-	if (palm_err == -ENODEV)
+	if ((palm_err == -ENODEV) && (lap_err == -ENODEV))
 		return 0;
-	/* For all other errors we can flag the failure */
+	/* If both sensors error out - return an error */
+	if (palm_err && lap_err)
+		return palm_err ? palm_err : lap_err;
+	/*
+	 * If just one sensor not available, we still want the input device,
+	 * so just flag it and carry on
+	 */
 	if (palm_err)
-		return palm_err;
+		pr_info("Palm sensor returned error %d", palm_err);
+	if (lap_err)
+		pr_info("Lap sensor returned error %d", lap_err);
 
-	if (has_palmsensor) {
+	if (has_palmsensor || has_lapsensor) {
 		tpacpi_sw_dev = input_allocate_device();
 		if (!tpacpi_sw_dev)
 			return -ENOMEM;
@@ -9990,10 +10027,14 @@ static int tpacpi_proxsensor_init(struct ibm_init_struct *iibm)
 			input_set_capability(tpacpi_sw_dev, EV_SW, SW_PALMREST_PROXIMITY);
 			input_report_switch(tpacpi_sw_dev, SW_PALMREST_PROXIMITY, palmsensor_state);
 		}
-		palm_err = input_register_device(tpacpi_sw_dev);
-		if (palm_err) {
+		if (has_lapsensor) {
+			input_set_capability(tpacpi_sw_dev, EV_SW, SW_LAP_PROXIMITY);
+			input_report_switch(tpacpi_sw_dev, SW_LAP_PROXIMITY, lapsensor_state);
+		}
+		err = input_register_device(tpacpi_sw_dev);
+		if (err) {
 			input_free_device(tpacpi_sw_dev);
-			return palm_err;
+			return err;
 		}
 	}
 	return 0;
@@ -10057,8 +10098,10 @@ static void tpacpi_driver_event(const unsigned int hkey_event)
 		mutex_unlock(&kbdlight_mutex);
 	}
 
-	if (hkey_event == TP_HKEY_EV_THM_CSM_COMPLETED)
+	if (hkey_event == TP_HKEY_EV_THM_CSM_COMPLETED) {
 		dytc_lapmode_refresh();
+		proxsensor_refresh(false /* palm */, true /* lap */);
+	}
 
 }
 